<template>
  <q-page class="sign-in row justify-center items-center">
    <q-card class="card col-6">
      <div class="form">
        <q-field
          label="Prezývka"
          :error="errors.has('username')"
          :error-label="errors.first('username')"
        >
          <q-input
            name="username"
            :error="errors.has('username')"
            v-model="form.username"
            v-validate="'required'"
            @focus="focus = true"
            @blur="focus = false"
          />
        </q-field>
        <q-field
          label='Heslo'
          :error="errors.has('password')"
          :error-label="errors.first('password')"
        >
          <q-input
            name="password"
            :error="errors.has('password')"
            v-model="form.password"
            v-validate="{ required: true, min: 8, regex: /^.*(?=.*[a-z])(?=.*[A-Z])(?=.*\d).*$/ }"
            type="password"
            @focus="focus = true"
            @blur="focus = false"
          />
        </q-field>
      </div>
      <div class="row justify-between items-end">
        <router-link to="/registracia">
          Nemáte vytvorený účet? Zaregistrujte sa
        </router-link>
        <q-btn class="" color="primary" @click="submit">Odoslať</q-btn>
      </div>
    </q-card>
  </q-page>
</template>

<style lang="scss">
  .sign-in {
    .card {
      min-height: 300px;
      padding: 2rem;
      margin: 1rem 0;
    }
    .form {
      margin: 1rem;
    }
  }
</style>

<script>

export default {
  name: 'SignInPage',

  $_veeValidate: {
    validator: 'new'
  },

  data () {
    return {
      focus: false,
      form: {
        username: null,
        password: null
      }
    }
  },

  methods: {
    submit () {
      this.$validator.validateAll().then(async () => {
        if (this.errors.any()) {
          this.$q.notify(this.errors.first())
        } else {
          const result = await this.$store.dispatch('userManagement/signIn', this.form)
          if (result) {
            this.$router.push('/profil')
          } else {
            this.$q.notify('Niekde nastala chyba')
          }
        }
      })
    }
  }
}
</script>
